#!/usr/bin/python

#  mill pendant V1 Sammel Lothar 
import serial
import hal
import sys
import time
from struct import pack

# search your /dev for the port 
PORT = "/dev/ttyUSB0"
ser = serial.Serial(PORT, 9600)

#Now we create the HAL component and its pins
c = hal.component("pendant")
c.newpin("estop_activate",hal.HAL_BIT,hal.HAL_IN)
c.newpin("estop_reset",hal.HAL_BIT,hal.HAL_IN)
c.newpin("estop_is_activated",hal.HAL_BIT,hal.HAL_IN)

c.newpin("maschine_is_on",hal.HAL_BIT,hal.HAL_IN)
c.newpin("maschine_on",hal.HAL_BIT,hal.HAL_IN)
c.newpin("maschine_off",hal.HAL_BIT,hal.HAL_IN)

c.newpin("x_positiv_feed_move",hal.HAL_BIT,hal.HAL_IN)
c.newpin("y_positiv_feed_move",hal.HAL_BIT,hal.HAL_IN)
c.newpin("z_positiv_feed_move",hal.HAL_BIT,hal.HAL_IN)

c.newpin("x_negativ_feed_move",hal.HAL_BIT,hal.HAL_IN)
c.newpin("y_negativ_feed_move",hal.HAL_BIT,hal.HAL_IN)
c.newpin("z_negativ_feed_move",hal.HAL_BIT,hal.HAL_IN)

c.newpin("jog-x-plus-incr-1",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-x-plus-incr-2",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-x-plus-incr-3",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-x-plus-incr-4",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-x-minus-incr-1",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-x-minus-incr-2",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-x-minus-incr-3",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-x-minus-incr-4",hal.HAL_BIT,hal.HAL_IN)

c.newpin("jog-y-plus-incr-1",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-y-plus-incr-2",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-y-plus-incr-3",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-y-plus-incr-4",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-y-minus-incr-1",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-y-minus-incr-2",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-y-minus-incr-3",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-y-minus-incr-4",hal.HAL_BIT,hal.HAL_IN)

c.newpin("jog-z-plus-incr-1",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-z-plus-incr-2",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-z-plus-incr-3",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-z-plus-incr-4",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-z-minus-incr-1",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-z-minus-incr-2",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-z-minus-incr-3",hal.HAL_BIT,hal.HAL_IN)
c.newpin("jog-z-minus-incr-4",hal.HAL_BIT,hal.HAL_IN)

c.newpin("x_value_is",hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("y_value_is",hal.HAL_FLOAT, hal.HAL_IN)
c.newpin("z_value_is",hal.HAL_FLOAT, hal.HAL_IN)

c.newpin("feed_speed",hal.HAL_FLOAT, hal.HAL_IN)

c.newpin("pendant_is_connected",hal.HAL_BIT,hal.HAL_IN)
c.newpin("pendant_off",hal.HAL_BIT,hal.HAL_IN)
c.newpin("pendant_on",hal.HAL_BIT,hal.HAL_IN)


c.ready()

        
maschine_state = c['maschine_is_on']
estop_state = c['estop_is_activated']
#
# preset variables 
#
#pendandconnected LED
c["pendant_is_connected"] = 0
c["pendant_on"] = 0

#    feed var
c["x_positiv_feed_move"] = 0
c["y_positiv_feed_move"] = 0
c["z_positiv_feed_move"] = 0
c["x_negativ_feed_move"] = 0
c["y_negativ_feed_move"] = 0
c["z_negativ_feed_move"] = 0
#     jog var 
c["jog-x-plus-incr-1"] = 0
c["jog-x-plus-incr-2"] = 0
c["jog-x-plus-incr-3"] = 0
c["jog-x-plus-incr-4"] = 0
c["jog-x-minus-incr-1"] = 0
c["jog-x-minus-incr-2"] = 0
c["jog-x-minus-incr-3"] = 0
c["jog-x-minus-incr-4"] = 0

c["jog-y-plus-incr-1"] = 0
c["jog-y-plus-incr-2"] = 0
c["jog-y-plus-incr-3"] = 0
c["jog-y-plus-incr-4"] = 0
c["jog-y-minus-incr-1"] = 0
c["jog-y-minus-incr-2"] = 0
c["jog-y-minus-incr-3"] = 0
c["jog-y-minus-incr-4"] = 0

c["jog-z-plus-incr-1"] = 0
c["jog-z-plus-incr-2"] = 0
c["jog-z-plus-incr-3"] = 0
c["jog-z-plus-incr-4"] = 0
c["jog-z-minus-incr-1"] = 0
c["jog-z-minus-incr-2"] = 0
c["jog-z-minus-incr-3"] = 0
c["jog-z-minus-incr-4"] = 0

#loop 3 times to update emc->pedant axis value if changed  
update_counter = 0
x_update_value_requierd = 1
y_update_value_requierd = 1
z_update_value_requierd = 1
x_update_counter = 3 
y_update_counter = 3 
z_update_counter = 3 
# preset the axis values
x_at_value = 0.000
y_at_value = 0.000
z_at_value = 0.000
#preset speed
feed_speed = 50.00
c['feed_speed'] = feed_speed
# variable for mode select
feed_enabled = 0
jog_enabled = 0
# mashine select
mashine_select_counter  = 10
maschine = 1 # minimill select
#vars 
connection_alive_counter  = 0
incremet_selected =0
running = 0
time.sleep(3) #wait for init pendand after connect

def toggle_var(component,key):
    time.sleep(0.1)
    component[key] = 1
    time.sleep(0.05)
    component[key] = 0

def transmit(data):
    if (ser.isOpen()):
        print data
        to_send=data
        if (type(data)== float):
            to_send = pack('f',round(data,3))
        time.sleep(0.05)
        ser.write(to_send)# connection alive to pendand
        time.sleep(0.05)
    else:
        print "PORT DOWN "
        running = 0

while (running == 0):
    time.sleep(0.5)
    # PYVCP Reconnect button
    if ((c["pendant_on"] == 1 ) and not (ser.isOpen())):
        ser = serial.Serial(PORT, 9600)
        c["pendant_on"] = 0
        running = 1
    # pendand connection down     
    if (ser.isOpen()):
        running = 1
    else:
        running = 0
    # pYVCP led disable    
    if (c["pendant_is_connected"] == 1):
        c["pendant_is_connected"] = 0
                    
    while (running == 1):
        #time.sleep(0.05)
        #KEEP connection allive every 5th while loop -> pendand indicading conneced
        if (connection_alive_counter == 10):
            connection_alive_counter = 0
            transmit("C+")# connection alive to pendand
        connection_alive_counter = connection_alive_counter + 1
            

        if (x_update_counter > 0 ):
            x_update_counter -= 1
            x_update_value_requierd = 1
        if (y_update_counter > 0 ):
            y_update_counter -= 1
            y_update_value_requierd = 1
        if (z_update_counter > 0 ):
            z_update_counter -=1
            z_update_value_requierd = 1

        update_counter = update_counter + 1
        if(x_at_value != c['x_value_is']):# X has Changed 
            x_update_value_requierd=1
            x_update_counter = 3 #repead telling 3 times
        if(x_update_value_requierd ==1):#transmit new x value to pendant    
            transmit("XM")
            x_at_value = c['x_value_is']
            transmit(x_at_value)
        if(y_at_value != c['y_value_is']): # Y has Changed
            y_update_value_requierd=1
            y_update_counter = 3 
        if(y_update_value_requierd ==1):    
            transmit("YM")
            y_at_value = c['y_value_is']
            transmit(y_at_value)
        if(z_at_value != c['z_value_is']): # z has changed
            z_update_value_requierd=1
            z_update_counter = 3
        if(z_update_value_requierd ==1):
            transmit("ZM")
            z_at_value = c['z_value_is']
            transmit(z_at_value)

        # mashine select 5 times to the pednand
        if ( mashine_select_counter > 0):
            transmit("R1")#router 1
            mashine_select_counter -= 1
        #mashine state F2 to pendant 
        if(maschine_state != c['maschine_is_on']):
            if (c['maschine_is_on'] ==1):
                transmit("+D")
            if (c['maschine_is_on'] ==0):
                transmit("-D")
            #update the machine state variable
            maschine_state = c['maschine_is_on']

        if(estop_state != c['estop_is_activated']):
            if (c['estop_is_activated'] == 1 ):
                transmit("+E")
            if (c['estop_is_activated'] == 0 ):
                transmit("-E")
            #update the machine state variable
            estop_state = c['estop_is_activated']
        #safty if it got miss send again 
        if (connection_alive_counter == 2):
            if (c['estop_is_activated'] == 1 ):
                transmit("+E")
            if (c['estop_is_activated'] == 0 ):
                transmit("-E")
        if (connection_alive_counter == 5):
            if (c['maschine_is_on'] == 1 ):
                transmit("+D")
            if (c['maschine_is_on'] == 0 ):
                transmit("-D")
        if (connection_alive_counter == 8):
            transmit("R1")
        
        # now read if somthing happend on the pednand 
        if ((ser.isOpen())and(ser.inWaiting()>1)):
            key = ser.readline()
            #print "Es Warten Noch" + str(ser.inWaiting())
            print key    
            if (ser.inWaiting()>28):
                print "flush FFFFF"
                ser.flushInput()
                ser.flushOutput()
            if("+E" in key ):#estop set
                if (estop_state==0):
                    c['estop_activate'] = 1
                    c['estop_reset'] = 0
            if("-E" in key ):#estop reset
                if (estop_state==1):
                    c['estop_activate'] = 0
                    c['estop_reset'] = 1

            if("+D" in key ):#driveron
                if (maschine_state==0):
                    c['maschine_on'] = 1
                    c['maschine_off'] = 0
            if("-D" in key ):#driverOff
                if (maschine_state==1):
                    c['maschine_on'] = 0
                    c['maschine_off'] = 1
            if("CU" in key):
                c["pendant_is_connected"] = 1
            if("FE" in key):#feed enabeled
                feed_enabled = 1
            if("FD" in key):#feed Disabled
                feed_enabled = 0
                c["x_positiv_feed_move"] = 0
                c["y_positiv_feed_move"] = 0
                c["z_positiv_feed_move"] = 0
                c["x_negativ_feed_move"] = 0
                c["y_negativ_feed_move"] = 0
                c["z_negativ_feed_move"] = 0

            if("JE" in key):#feed enabeled
                jog_enabled = 1
            if("JD" in key):#feed enabeled
                jog_enabled = 0
            # FEED MOVE 
            if (feed_enabled==1):
                # select feedrate
                if("J1" in key):
                    feed_speed=10.0
                if("J2" in key):
                    feed_speed=50.0
                if("J3" in key):
                    feed_speed=150.0
                if("J4" in key):
                    feed_speed=300.0
                #set feedrate     
                if (c['feed_speed'] != feed_speed):
                    c['feed_speed'] = feed_speed
                # check feed(jog) Array Recived FEXxYxZx x can be + - 0    
                if ("X0" in key):
                    c["x_positiv_feed_move"] = 0
                    c["x_negativ_feed_move"] = 0
                if ("Y0" in key):
                    c["y_positiv_feed_move"] = 0
                    c["y_negativ_feed_move"] = 0
                if ("Z0" in key):
                    c["z_positiv_feed_move"] = 0
                    c["z_negativ_feed_move"] = 0
                if (("X+" in key) and (c["x_negativ_feed_move"] == 0)):
                    c["x_positiv_feed_move"] = 1
                if (("Y+" in key) and (c["y_negativ_feed_move"] == 0)):
                    c["y_positiv_feed_move"] = 1
                if (("Z+" in key) and (c["z_negativ_feed_move"] == 0)):
                    c["z_positiv_feed_move"] = 1
                if (("X-" in key) and (c["x_positiv_feed_move"] == 0)):
                    c["x_negativ_feed_move"] = 1
                if (("Y-" in key) and (c["y_positiv_feed_move"] == 0)):
                    c["y_negativ_feed_move"] = 1
                if (("Z-" in key) and (c["z_positiv_feed_move"] == 0)):
                    c["z_negativ_feed_move"] = 1
            # JOG MOVE    
            if ((jog_enabled == 1) and ( c['maschine_is_on'] ==1 )):
                # x positv jog
                if(("X+" in key) and ("J1" in key)):
                    toggle_var(c,"jog-x-plus-incr-1")
                if(("X+" in key) and ("J2" in key)):
                    toggle_var(c,"jog-x-plus-incr-2")
                if(("X+" in key) and ("J3" in key)):
                    toggle_var(c,"jog-x-plus-incr-3")
                if(("X+" in key) and ("J4" in key)):
                    toggle_var(c,"jog-x-plus-incr-4")
                #x negativ jog    
                if(("X-" in key) and ("J1" in key)):
                    toggle_var(c,"jog-x-minus-incr-1")
                if(("X-" in key) and ("J2" in key)):
                    toggle_var(c,"jog-x-minus-incr-2")
                if(("X-" in key) and ("J3" in key)):
                    toggle_var(c,"jog-x-minus-incr-3")
                if(("X-" in key) and ("J4" in key)):
                    toggle_var(c,"jog-x-minus-incr-4")
                # Y positv jog
                if(("Y+" in key) and ("J1" in key)):
                    toggle_var(c,"jog-y-plus-incr-1")
                if(("Y+" in key) and ("J2" in key)):
                    toggle_var(c,"jog-y-plus-incr-2")
                if(("Y+" in key) and ("J3" in key)):
                    toggle_var(c,"jog-y-plus-incr-3")
                if(("Y+" in key) and ("J4" in key)):
                    toggle_var(c,"jog-y-plus-incr-4")
                # Y negativ jog    
                if(("Y-" in key) and ("J1" in key)):
                    toggle_var(c,"jog-y-minus-incr-1")
                if(("Y-" in key) and ("J2" in key)):
                    toggle_var(c,"jog-y-minus-incr-2")
                if(("Y-" in key) and ("J3" in key)):
                    toggle_var(c,"jog-y-minus-incr-3")
                if(("Y-" in key) and ("J4" in key)):
                    toggle_var(c,"jog-y-minus-incr-4")
                # Z positv jog
                if(("Z+" in key) and ("J1" in key)):
                    toggle_var(c,"jog-z-plus-incr-1")
                if(("Z+" in key) and ("J2" in key)):
                    toggle_var(c,"jog-z-plus-incr-2")
                if(("Z+" in key) and ("J3" in key)):
                    toggle_var(c,"jog-z-plus-incr-3")
                if(("Z+" in key) and ("J4" in key)):
                    toggle_var(c,"jog-z-plus-incr-4")
                # Z negativ jog    
                if(("Z-" in key) and ("J1" in key)):
                    toggle_var(c,"jog-z-minus-incr-1")
                if(("Z-" in key) and ("J2" in key)):
                    toggle_var(c,"jog-z-minus-incr-2")
                if(("Z-" in key) and ("J3" in key)):
                    toggle_var(c,"jog-z-minus-incr-3")
                if(("Z-" in key) and ("J4" in key)):
                    toggle_var(c,"jog-z-minus-incr-4")

            if("CD" in key ):#Connection down 
                c["pendant_is_connected"] = 0
                running=0
                ser.close()
        if ((c["pendant_off"] ==1) and (ser.isOpen() )):
            ser.close()
            c["pendant_off"] =0
            running =0
            
    #end while 
